Index: sys/dev/iscsi/initiator/iscsi.c
===================================================================
--- sys/dev/iscsi/initiator/iscsi.c	(.../stable/8)	(revision 201781)
+++ sys/dev/iscsi/initiator/iscsi.c	(.../projects/capabilities8)	(revision 205872)
@@ -35,6 +35,7 @@
 #include "opt_iscsi_initiator.h"
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/kernel.h>
 #include <sys/module.h>
 #include <sys/conf.h>
@@ -399,11 +400,15 @@
      if(sp->soc != NULL)
 	  isc_stop_receiver(sp);
 
-     error = fget(td, fd, &sp->fp);
+     /*
+      * XXXRW: Possibly should be CAP_SOCK_ALL?
+      */
+     error = fget(td, fd, CAP_READ | CAP_WRITE | CAP_SHUTDOWN, &sp->fp);
      if(error)
 	  return error;
 
-     if((error = fgetsock(td, fd, &sp->soc, 0)) == 0) {
+     if((error = fgetsock(td, fd, CAP_READ | CAP_WRITE | CAP_SHUTDOWN,
+	&sp->soc, 0)) == 0) {
 	  sp->td = td;
 	  isc_start_receiver(sp);
      }

Index: sys/dev/tdfx/tdfx_linux.c
===================================================================
--- sys/dev/tdfx/tdfx_linux.c	(.../stable/8)	(revision 201781)
+++ sys/dev/tdfx/tdfx_linux.c	(.../projects/capabilities8)	(revision 205872)
@@ -28,6 +28,7 @@
 __FBSDID("$FreeBSD$");
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/file.h>
 #include <sys/kernel.h>
 #include <sys/module.h>
@@ -53,7 +54,7 @@
 
    struct file *fp;
 
-   if ((error = fget(td, args->fd, &fp)) != 0)
+   if ((error = fget(td, args->fd, CAP_IOCTL, &fp)) != 0)
 	   return (error);
    /* We simply copy the data and send it right to ioctl */
    copyin((caddr_t)args->arg, &d_pio, sizeof(d_pio));
Index: sys/bsm/audit_errno.h
===================================================================
--- sys/bsm/audit_errno.h	(.../stable/8)	(revision 201781)
+++ sys/bsm/audit_errno.h	(.../projects/capabilities8)	(revision 205872)
@@ -205,6 +205,7 @@
 #define	BSM_ERRNO_EKEYEXPIRED		220	/* Linux-specific. */
 #define	BSM_ERRNO_EKEYREVOKED		221	/* Linux-specific. */
 #define	BSM_ERRNO_EKEYREJECTED		222	/* Linux-specific. */
+#define	BSM_ERRNO_ENOTCAPABLE		223	/* FreeBSD-specific. */
 
 /*
  * In the event that OpenBSM doesn't have a file representation of a local
Index: sys/vm/vm_map.c
===================================================================
--- sys/vm/vm_map.c	(.../stable/8)	(revision 201781)
+++ sys/vm/vm_map.c	(.../projects/capabilities8)	(revision 205872)
@@ -1136,7 +1136,7 @@
 	    ((protoeflags & MAP_ENTRY_NEEDS_COPY) || object == NULL))) {
 		if (!(cow & MAP_ACC_CHARGED) && !swap_reserve(end - start))
 			return (KERN_RESOURCE_SHORTAGE);
-		KASSERT(object == NULL || (cow & MAP_ENTRY_NEEDS_COPY) ||
+		KASSERT(object == NULL || (protoeflags & MAP_ENTRY_NEEDS_COPY) ||
 		    object->uip == NULL,
 		    ("OVERCOMMIT: vm_map_insert o %p", object));
 		uip = curthread->td_ucred->cr_ruidinfo;
Index: sys/vm/vm_mmap.c
===================================================================
--- sys/vm/vm_mmap.c	(.../stable/8)	(revision 201781)
+++ sys/vm/vm_mmap.c	(.../projects/capabilities8)	(revision 205872)
@@ -48,6 +48,7 @@
 
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/capability.h>
 #include <sys/kernel.h>
 #include <sys/lock.h>
 #include <sys/mutex.h>
@@ -215,12 +216,13 @@
 	struct vnode *vp;
 	vm_offset_t addr;
 	vm_size_t size, pageoff;
-	vm_prot_t prot, maxprot;
+	vm_prot_t cap_maxprot, prot, maxprot;
 	void *handle;
 	objtype_t handle_type;
 	int flags, error;
 	off_t pos;
 	struct vmspace *vms = td->td_proc->p_vmspace;
+	cap_rights_t rights;
 
 	addr = (vm_offset_t) uap->addr;
 	size = uap->len;
@@ -297,14 +299,27 @@
 		 */
 		handle = NULL;
 		handle_type = OBJT_DEFAULT;
+		cap_maxprot = VM_PROT_ALL;
 		maxprot = VM_PROT_ALL;
 		pos = 0;
 	} else {
 		/*
-		 * Mapping file, get fp for validation and
-		 * don't let the descriptor disappear on us if we block.
+		 * Mapping file, get fp for validation and don't let the
+		 * descriptor disappear on us if we block.  Check capability
+		 * rights, but also return the maximum rights to be combined
+		 * with maxprot later.
 		 */
-		if ((error = fget(td, uap->fd, &fp)) != 0)
+		rights = CAP_MMAP;
+		if (prot & PROT_READ)
+			rights |= CAP_READ;
+		if ((flags & MAP_SHARED) != 0) {
+			if (prot & PROT_WRITE)
+				rights |= CAP_WRITE;
+		}
+		if (prot & PROT_EXEC)
+			rights |= CAP_MAPEXEC;
+		if ((error = fget_mmap(td, uap->fd, rights, &cap_maxprot,
+		    &fp)) != 0)
 			goto done;
 		if (fp->f_type == DTYPE_SHM) {
 			handle = fp->f_data;
@@ -371,6 +386,7 @@
 			}
 		} else if (vp->v_type != VCHR || (fp->f_flag & FWRITE) != 0) {
 			maxprot |= VM_PROT_WRITE;
+			cap_maxprot |= VM_PROT_WRITE;
 		}
 		handle = (void *)vp;
 		handle_type = OBJT_VNODE;
@@ -389,6 +405,7 @@
 	}
 
 	td->td_fpop = fp;
+	maxprot &= cap_maxprot;
 	error = vm_mmap(&vms->vm_map, &addr, size, prot, maxprot,
 	    flags, handle_type, handle, pos);
 	td->td_fpop = NULL;
Index: sys/compat/freebsd32/freebsd32_syscall.h
===================================================================
--- sys/compat/freebsd32/freebsd32_syscall.h	(.../stable/8)	(revision 201781)
+++ sys/compat/freebsd32/freebsd32_syscall.h	(.../projects/capabilities8)	(revision 205872)
@@ -386,5 +386,13 @@
 #define	FREEBSD32_SYS_freebsd32_msgctl	511
 #define	FREEBSD32_SYS_freebsd32_shmctl	512
 #define	FREEBSD32_SYS_lpathconf	513
+#define	FREEBSD32_SYS_cap_new	514
+#define	FREEBSD32_SYS_cap_getrights	515
+#define	FREEBSD32_SYS_cap_enter	516
+#define	FREEBSD32_SYS_cap_getmode	517
+#define	FREEBSD32_SYS_pdfork	518
+#define	FREEBSD32_SYS_pdkill	519
+#define	FREEBSD32_SYS_pdgetpid	520
+#define	FREEBSD32_SYS_pdwait	521
 #define	FREEBSD32_SYS_freebsd32_pselect	522
 #define	FREEBSD32_SYS_MAXSYSCALL	523
Index: sys/compat/freebsd32/freebsd32_sysent.c
===================================================================
--- sys/compat/freebsd32/freebsd32_sysent.c	(.../stable/8)	(revision 201781)
+++ sys/compat/freebsd32/freebsd32_sysent.c	(.../projects/capabilities8)	(revision 205872)
@@ -558,13 +558,13 @@
 	{ AS(freebsd32_msgctl_args), (sy_call_t *)freebsd32_msgctl, AUE_MSGCTL, NULL, 0, 0, 0 },	/* 511 = freebsd32_msgctl */
 	{ AS(freebsd32_shmctl_args), (sy_call_t *)freebsd32_shmctl, AUE_SHMCTL, NULL, 0, 0, 0 },	/* 512 = freebsd32_shmctl */
 	{ AS(lpathconf_args), (sy_call_t *)lpathconf, AUE_LPATHCONF, NULL, 0, 0, 0 },	/* 513 = lpathconf */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0 },			/* 514 = cap_new */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0 },			/* 515 = cap_getrights */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0 },			/* 516 = cap_enter */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0 },			/* 517 = cap_getmode */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0 },			/* 518 = pdfork */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0 },			/* 519 = pdkill */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0 },			/* 520 = pdgetpid */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0 },			/* 521 = pdwait */
+	{ AS(cap_new_args), (sy_call_t *)cap_new, AUE_CAP_NEW, NULL, 0, 0, 0 },	/* 514 = cap_new */
+	{ AS(cap_getrights_args), (sy_call_t *)cap_getrights, AUE_CAP_GETRIGHTS, NULL, 0, 0, 0 },	/* 515 = cap_getrights */
+	{ 0, (sy_call_t *)cap_enter, AUE_CAP_ENTER, NULL, 0, 0, 0 },	/* 516 = cap_enter */
+	{ AS(cap_getmode_args), (sy_call_t *)cap_getmode, AUE_CAP_GETMODE, NULL, 0, 0, 0 },	/* 517 = cap_getmode */
+	{ AS(pdfork_args), (sy_call_t *)pdfork, AUE_NULL, NULL, 0, 0, 0 },	/* 518 = pdfork */
+	{ AS(pdkill_args), (sy_call_t *)pdkill, AUE_NULL, NULL, 0, 0, 0 },	/* 519 = pdkill */
+	{ AS(pdgetpid_args), (sy_call_t *)pdgetpid, AUE_NULL, NULL, 0, 0, 0 },	/* 520 = pdgetpid */
+	{ AS(pdwait_args), (sy_call_t *)pdwait, AUE_NULL, NULL, 0, 0, 0 },	/* 521 = pdwait */
 	{ AS(freebsd32_pselect_args), (sy_call_t *)freebsd32_pselect, AUE_SELECT, NULL, 0, 0, 0 },	/* 522 = freebsd32_pselect */
 };
Index: sys/compat/freebsd32/syscalls.master
===================================================================
--- sys/compat/freebsd32/syscalls.master	(.../stable/8)	(revision 201781)
+++ sys/compat/freebsd32/syscalls.master	(.../projects/capabilities8)	(revision 205872)
@@ -905,14 +905,16 @@
 512	AUE_SHMCTL	STD	{ int freebsd32_shmctl(int shmid, int cmd, \
 				    struct shmid_ds32 *buf); }
 513	AUE_LPATHCONF	NOPROTO	{ int lpathconf(char *path, int name); }
-514	AUE_CAP_NEW	UNIMPL	cap_new
-515	AUE_CAP_GETRIGHTS	UNIMPL	cap_getrights
-516	AUE_CAP_ENTER	UNIMPL	cap_enter
-517	AUE_CAP_GETMODE	UNIMPL	cap_getmode
-518	AUE_PDFORK	UNIMPL	pdfork
-519	AUE_PDKILL	UNIMPL	pdkill
-520	AUE_PDGETPID	UNIMPL	pdgetpid
-521	AUE_PDWAIT	UNIMPL	pdwait
+514	AUE_CAP_NEW	NOPROTO	{ int cap_new(int fd, u_int64_t rights); }
+515	AUE_CAP_GETRIGHTS	NOPROTO	{ int cap_getrights(int fd, \
+				    u_int64_t *rightsp); }
+516	AUE_CAP_ENTER	NOPROTO	{ int cap_enter(void); }
+517	AUE_CAP_GETMODE	NOPROTO	{ int cap_getmode(u_int *modep); }
+518	AUE_NULL	NOPROTO	{ int pdfork(int *fdp); }
+519	AUE_NULL	NOPROTO	{ int pdkill(int fd, int signum); }
+520	AUE_NULL	NOPROTO	{ int pdgetpid(int fd, pid_t *pidp); }
+521	AUE_NULL	NOPROTO	{ int pdwait(int fd, int *status, \
+				    int options, struct rusage *rusage); }
 522	AUE_SELECT	STD	{ int freebsd32_pselect(int nd, fd_set *in, \
 				    fd_set *ou, fd_set *ex, \
 				    const struct timespec32 *ts, \
Index: sys/compat/freebsd32/freebsd32_ioctl.c
===================================================================
--- sys/compat/freebsd32/freebsd32_ioctl.c	(.../stable/8)	(revision 201781)
+++ sys/compat/freebsd32/freebsd32_ioctl.c	(.../projects/capabilities8)	(revision 205872)
@@ -33,6 +33,7 @@
 #include "opt_compat.h"
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/cdio.h>
 #include <sys/fcntl.h>
 #include <sys/filio.h>
@@ -207,7 +208,7 @@
 	struct file *fp;
 	int error;
 
-	if ((error = fget(td, uap->fd, &fp)) != 0)
+	if ((error = fget(td, uap->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 	if ((fp->f_flag & (FREAD | FWRITE)) == 0) {
 		fdrop(fp, td);
Index: sys/compat/freebsd32/freebsd32_syscalls.c
===================================================================
--- sys/compat/freebsd32/freebsd32_syscalls.c	(.../stable/8)	(revision 201781)
+++ sys/compat/freebsd32/freebsd32_syscalls.c	(.../projects/capabilities8)	(revision 205872)
@@ -521,13 +521,13 @@
 	"freebsd32_msgctl",			/* 511 = freebsd32_msgctl */
 	"freebsd32_shmctl",			/* 512 = freebsd32_shmctl */
 	"lpathconf",			/* 513 = lpathconf */
-	"#514",			/* 514 = cap_new */
-	"#515",			/* 515 = cap_getrights */
-	"#516",			/* 516 = cap_enter */
-	"#517",			/* 517 = cap_getmode */
-	"#518",			/* 518 = pdfork */
-	"#519",			/* 519 = pdkill */
-	"#520",			/* 520 = pdgetpid */
-	"#521",			/* 521 = pdwait */
+	"cap_new",			/* 514 = cap_new */
+	"cap_getrights",			/* 515 = cap_getrights */
+	"cap_enter",			/* 516 = cap_enter */
+	"cap_getmode",			/* 517 = cap_getmode */
+	"pdfork",			/* 518 = pdfork */
+	"pdkill",			/* 519 = pdkill */
+	"pdgetpid",			/* 520 = pdgetpid */
+	"pdwait",			/* 521 = pdwait */
 	"freebsd32_pselect",			/* 522 = freebsd32_pselect */
 };
Index: sys/compat/linux/linux_file.c
===================================================================
--- sys/compat/linux/linux_file.c	(.../stable/8)	(revision 201781)
+++ sys/compat/linux/linux_file.c	(.../projects/capabilities8)	(revision 205872)
@@ -33,6 +33,7 @@
 
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/capability.h>
 #include <sys/conf.h>
 #include <sys/dirent.h>
 #include <sys/fcntl.h>
@@ -139,7 +140,7 @@
 	     * having the same filedesc could use that fd without
 	     * checking below.
 	     */
-	    error = fget(td, fd, &fp);
+	    error = fget(td, fd, CAP_IOCTL, &fp);
 	    if (!error) {
 		    sx_slock(&proctree_lock);
 		    PROC_LOCK(p);
@@ -1043,8 +1044,9 @@
 	error = pread(td, &bsd);
 
 	if (error == 0) {
+		/* XXXRW: No capability rights should be OK. */
    	   	/* This seems to violate POSIX but linux does it */
-   	   	if ((error = fgetvp(td, uap->fd, &vp)) != 0)
+   	   	if ((error = fgetvp(td, uap->fd, 0, &vp)) != 0)
    		   	return (error);
 		if (vp->v_type == VDIR) {
    		   	vrele(vp);
@@ -1392,8 +1394,12 @@
 		 * XXX some Linux applications depend on F_SETOWN having no
 		 * significant effect for pipes (SIGIO is not delivered for
 		 * pipes under Linux-2.2.35 at least).
+		 *
+		 * Don't really need to check CAP_FCNTL here since real work
+		 * will depend on kern_fnctl(), but it's will give the right
+		 * error in the EINVAL case.
 		 */
-		error = fget(td, args->fd, &fp);
+		error = fget(td, args->fd, CAP_FCNTL, &fp);
 		if (error)
 			return (error);
 		if (fp->f_type == DTYPE_PIPE) {
Index: sys/compat/linux/linux_socket.c
===================================================================
--- sys/compat/linux/linux_socket.c	(.../stable/8)	(revision 201781)
+++ sys/compat/linux/linux_socket.c	(.../projects/capabilities8)	(revision 205872)
@@ -715,8 +715,10 @@
 	 * XXXRW: Instead of using fgetsock(), check that it is a
 	 * socket and use the file descriptor reference instead of
 	 * creating a new one.
+	 *
+	 * XXXRW: No capability rights required here?
 	 */
-	error = fgetsock(td, args->s, &so, &fflag);
+	error = fgetsock(td, args->s, 0, &so, &fflag);
 	if (error == 0) {
 		error = EISCONN;
 		if (fflag & FNONBLOCK) {
Index: sys/compat/linux/linux_stats.c
===================================================================
--- sys/compat/linux/linux_stats.c	(.../stable/8)	(revision 201781)
+++ sys/compat/linux/linux_stats.c	(.../projects/capabilities8)	(revision 205872)
@@ -141,8 +141,11 @@
 	struct vnode *vp;
 	int major, minor;
 
+	/*
+	 * XXXRW: No capability rights required here.
+	 */
 	if ((!S_ISCHR(buf->st_mode) && !S_ISBLK(buf->st_mode)) ||
-	    fget(td, fd, &fp) != 0)
+	    fget(td, fd, 0, &fp) != 0)
 		return;
 	vp = fp->f_vnode;
 	if (vp != NULL && vp->v_rdev != NULL &&
Index: sys/compat/linux/linux_ioctl.c
===================================================================
--- sys/compat/linux/linux_ioctl.c	(.../stable/8)	(revision 201781)
+++ sys/compat/linux/linux_ioctl.c	(.../projects/capabilities8)	(revision 205872)
@@ -34,6 +34,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sysproto.h>
+#include <sys/capability.h>
 #include <sys/cdio.h>
 #include <sys/dvdio.h>
 #include <sys/conf.h>
@@ -166,7 +167,7 @@
 	u_int sectorsize, fwcylinders, fwheads, fwsectors;
 	off_t mediasize, bytespercyl;
 
-	if ((error = fget(td, args->fd, &fp)) != 0)
+	if ((error = fget(td, args->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 	switch (args->cmd & 0xffff) {
 	case LINUX_HDIO_GET_GEO:
@@ -247,7 +248,7 @@
 	u_int sectorsize;
 	off_t mediasize;
 
-	if ((error = fget(td, args->fd, &fp)) != 0)
+	if ((error = fget(td, args->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 	switch (args->cmd & 0xffff) {
 	case LINUX_BLKGETSIZE:
@@ -673,7 +674,7 @@
 	struct file *fp;
 	int error;
 
-	if ((error = fget(td, args->fd, &fp)) != 0)
+	if ((error = fget(td, args->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 
 	switch (args->cmd & 0xffff) {
@@ -1413,7 +1414,7 @@
 	struct file *fp;
 	int error;
 
-	if ((error = fget(td, args->fd, &fp)) != 0)
+	if ((error = fget(td, args->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 	switch (args->cmd & 0xffff) {
 
@@ -1934,7 +1935,7 @@
 	struct file *fp;
 	int error;
 
-	if ((error = fget(td, args->fd, &fp)) != 0)
+	if ((error = fget(td, args->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 	switch (args->cmd & 0xffff) {
 
@@ -2325,7 +2326,7 @@
 	ifp = NULL;
 	error = 0;
 
-	if ((error = fget(td, args->fd, &fp)) != 0)
+	if ((error = fget(td, args->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 	type = fp->f_type;
 	fdrop(fp, td);
@@ -2551,7 +2552,7 @@
 	struct file *fp;
 	int error, type;
 
-	if ((error = fget(td, args->fd, &fp)) != 0)
+	if ((error = fget(td, args->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 	type = fp->f_type;
 	fdrop(fp, td);
@@ -2577,7 +2578,7 @@
 	u_long cmd;
 	int error;
 
-	if ((error = fget(td, args->fd, &fp)) != 0) {
+	if ((error = fget(td, args->fd, CAP_IOCTL, &fp)) != 0) {
 		printf("sg_linux_ioctl: fget returned %d\n", error);
 		return (error);
 	}
@@ -2633,7 +2634,7 @@
 		    (unsigned long)args->cmd);
 #endif
 
-	if ((error = fget(td, args->fd, &fp)) != 0)
+	if ((error = fget(td, args->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 	if ((fp->f_flag & (FREAD|FWRITE)) == 0) {
 		fdrop(fp, td);
Index: sys/compat/svr4/svr4_stream.c
===================================================================
--- sys/compat/svr4/svr4_stream.c	(.../stable/8)	(revision 201781)
+++ sys/compat/svr4/svr4_stream.c	(.../projects/capabilities8)	(revision 205872)
@@ -42,6 +42,7 @@
 #include "opt_ktrace.h"
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/systm.h>
 #include <sys/fcntl.h>
 #include <sys/filedesc.h>
@@ -1448,7 +1449,7 @@
 	struct file     *fp;
 	int error;
 
-	if ((error = fget(td, uap->fd, &fp)) != 0) {
+	if ((error = fget(td, uap->fd, CAP_WRITE, &fp)) != 0) {
 #ifdef DEBUG_SVR4
 	        uprintf("putmsg: bad fp\n");
 #endif
@@ -1620,7 +1621,7 @@
 	struct file     *fp;
 	int error;
 
-	if ((error = fget(td, uap->fd, &fp)) != 0) {
+	if ((error = fget(td, uap->fd, CAP_READ, &fp)) != 0) {
 #ifdef DEBUG_SVR4
 	        uprintf("getmsg: bad fp\n");
 #endif
Index: sys/compat/svr4/svr4_filio.c
===================================================================
--- sys/compat/svr4/svr4_filio.c	(.../stable/8)	(revision 201781)
+++ sys/compat/svr4/svr4_filio.c	(.../projects/capabilities8)	(revision 205872)
@@ -120,7 +120,7 @@
      ra.buf = uap->buf;
      ra.nbyte = uap->nbyte;
 
-     if (fget(td, uap->fd, &fp) != 0) {
+     if (fget(td, uap->fd, CAP_READ, &fp) != 0) {
        DPRINTF(("Something fishy with the user-supplied file descriptor...\n"));
        return EBADF;
      }
Index: sys/compat/svr4/svr4_fcntl.c
===================================================================
--- sys/compat/svr4/svr4_fcntl.c	(.../stable/8)	(revision 201781)
+++ sys/compat/svr4/svr4_fcntl.c	(.../projects/capabilities8)	(revision 205872)
@@ -33,6 +33,7 @@
 __FBSDID("$FreeBSD$");
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/systm.h>
 #include <sys/file.h>
 #include <sys/filedesc.h>
@@ -261,7 +262,7 @@
 	int error, *retval;
 
 	retval = td->td_retval;
-	if ((error = fgetvp(td, fd, &vp)) != 0)
+	if ((error = fgetvp(td, fd, CAP_REVOKE, &vp)) != 0)
 		return (error);
 
 	if (vp->v_type != VCHR && vp->v_type != VBLK) {
@@ -313,7 +314,7 @@
 	/*
 	 * We only support truncating the file.
 	 */
-	if ((error = fget(td, fd, &fp)) != 0)
+	if ((error = fget(td, fd, CAP_FTRUNCATE, &fp)) != 0)
 		return (error);
 
 	vp = fp->f_vnode;
@@ -392,7 +393,7 @@
 #if defined(NOTYET)
 		struct file	*fp;
 
-		error = fget(td, retval, &fp);
+		error = fget(td, retval, CAP_IOCTL, &fp);
 		PROC_UNLOCK(p);
 		/*
 		 * we may have lost a race the above open() and
Index: sys/compat/svr4/svr4_ioctl.c
===================================================================
--- sys/compat/svr4/svr4_ioctl.c	(.../stable/8)	(revision 201781)
+++ sys/compat/svr4/svr4_ioctl.c	(.../projects/capabilities8)	(revision 205872)
@@ -30,6 +30,7 @@
 __FBSDID("$FreeBSD$");
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/proc.h>
 #include <sys/file.h>
 #include <sys/filedesc.h>
@@ -102,7 +103,7 @@
 	retval = td->td_retval;
 	cmd = uap->com;
 
-	if ((error = fget(td, uap->fd, &fp)) != 0)
+	if ((error = fget(td, uap->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 
 	if ((fp->f_flag & (FREAD | FWRITE)) == 0) {
Index: sys/i386/linux/linux_machdep.c
===================================================================
--- sys/i386/linux/linux_machdep.c	(.../stable/8)	(revision 201781)
+++ sys/i386/linux/linux_machdep.c	(.../projects/capabilities8)	(revision 205872)
@@ -31,6 +31,7 @@
 
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/capability.h>
 #include <sys/file.h>
 #include <sys/fcntl.h>
 #include <sys/imgact.h>
@@ -691,9 +692,12 @@
 		 * The file descriptor fildes is opened with
 		 * read permission, regardless of the
 		 * protection options specified.
+		 *
+		 * XXXRW: The real work is done in the FreeBSD mmap(), so
+		 * just checking CAP_MMAP here is fine.
 		 */
 
-		if ((error = fget(td, bsd_args.fd, &fp)) != 0)
+		if ((error = fget(td, bsd_args.fd, CAP_MMAP, &fp)) != 0)
 			return (error);
 		if (fp->f_type != DTYPE_VNODE) {
 			fdrop(fp, td);
Index: sys/i386/ibcs2/ibcs2_fcntl.c
===================================================================
--- sys/i386/ibcs2/ibcs2_fcntl.c	(.../stable/8)	(revision 201781)
+++ sys/i386/ibcs2/ibcs2_fcntl.c	(.../projects/capabilities8)	(revision 205872)
@@ -32,6 +32,7 @@
 
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/capability.h>
 #include <sys/fcntl.h>
 #include <sys/file.h>
 #include <sys/filedesc.h>
@@ -203,7 +204,10 @@
 		struct file *fp;
 		int error;
 
-		error = fget(td, td->td_retval[0], &fp);
+		/*
+		 * XXXRW: Think more about the capability right to use here.
+		 */
+		error = fget(td, td->td_retval[0], CAP_IOCTL, &fp);
 		PROC_UNLOCK(p);
 		if (error)
 			return (EBADF);
Index: sys/i386/ibcs2/ibcs2_ioctl.c
===================================================================
--- sys/i386/ibcs2/ibcs2_ioctl.c	(.../stable/8)	(revision 201781)
+++ sys/i386/ibcs2/ibcs2_ioctl.c	(.../projects/capabilities8)	(revision 205872)
@@ -31,6 +31,7 @@
 
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/capability.h>
 #include <sys/consio.h>
 #include <sys/fcntl.h>
 #include <sys/file.h>
@@ -333,7 +334,11 @@
 	struct file *fp;
 	int error;
 
-	if ((error = fget(td, uap->fd, &fp)) != 0) {
+	/*
+	 * XXXRW: Possibily we should switch (cmd) to generate a rights mask
+	 * to use here, see IBCS2_SIOCSOCKSYS for example.
+	 */
+	if ((error = fget(td, uap->fd, CAP_IOCTL, &fp)) != 0) {
 		DPRINTF(("ibcs2_ioctl(%d): bad fd %d ", p->p_pid,
 			 uap->fd));
 		return EBADF;
Index: sys/i386/conf/CAPABILITIES
===================================================================
--- sys/i386/conf/CAPABILITIES	(.../stable/8)	(revision 0)
+++ sys/i386/conf/CAPABILITIES	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,11 @@
+include GENERIC
+ident CAPABILITIES
+
+options CAPABILITIES
+options PROCDESC
+options KDTRACE_HOOKS
+options INVARIANT_SUPPORT
+options INVARIANTS
+options WITNESS
+options KDB
+options DDB
Index: sys/i386/i386/sys_machdep.c
===================================================================
--- sys/i386/i386/sys_machdep.c	(.../stable/8)	(revision 201781)
+++ sys/i386/i386/sys_machdep.c	(.../projects/capabilities8)	(revision 205872)
@@ -33,6 +33,7 @@
 __FBSDID("$FreeBSD$");
 
 #include "opt_kstack_pages.h"
+#include "opt_capabilities.h"
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -127,6 +128,10 @@
 		break;
 	}
 
+	/*
+	 * XXXRW: As new operations are added here, check that they are safe
+	 * in capability mode.
+	 */
 	switch(uap->op) {
 	case I386_GET_LDT:
 		error = i386_get_ldt(td, &kargs.largs);
@@ -159,6 +164,10 @@
 		error = i386_set_ioperm(td, &kargs.iargs);
 		break;
 	case I386_VM86:
+#ifdef CAPABILITIES
+		if (td->td_ucred->cr_flags & CRED_FLAG_CAPMODE)
+			return (EPERM);
+#endif
 		error = vm86_sysarch(td, uap->parms);
 		break;
 	case I386_GET_FSBASE:
@@ -316,6 +325,10 @@
 	int i, error;
 	char *iomap;
 
+#ifdef CAPABILITIES
+	if (td->td_ucred->cr_flags & CRED_FLAG_CAPMODE)
+		return (EPERM);
+#endif
 	if ((error = priv_check(td, PRIV_IO)) != 0)
 		return (error);
 	if ((error = securelevel_gt(td->td_ucred, 0)) != 0)
Index: sys/i386/i386/trap.c
===================================================================
--- sys/i386/i386/trap.c	(.../stable/8)	(revision 201781)
+++ sys/i386/i386/trap.c	(.../projects/capabilities8)	(revision 205872)
@@ -44,6 +44,7 @@
  * 386 Trap and System call handling
  */
 
+#include "opt_capabilities.h"
 #include "opt_clock.h"
 #include "opt_cpu.h"
 #include "opt_hwpmc_hooks.h"
@@ -70,6 +71,7 @@
 #include <sys/syscall.h>
 #include <sys/sysctl.h>
 #include <sys/sysent.h>
+#include <sys/ucred.h>
 #include <sys/uio.h>
 #include <sys/vmmeter.h>
 #ifdef KTRACE
@@ -1055,7 +1057,19 @@
 
 	td->td_syscalls++;
 
+#ifdef CAPABILITIES
+	/*
+	 * In capabilities mode, we only allow access to system calls flagged
+	 * SYF_CAPENABLED.
+	 */
 	if (error == 0) {
+		if (!(callp->sy_flags & SYF_CAPENABLED) &&
+		    (td->td_ucred->cr_flags & CRED_FLAG_CAPMODE))
+			error = ENOSYS;
+	}
+#endif
+
+	if (error == 0) {
 		td->td_retval[0] = 0;
 		td->td_retval[1] = frame->tf_edx;
 

Index: sys/cddl/contrib/opensolaris/uts/common/fs/zfs/zfs_ioctl.c
===================================================================
--- sys/cddl/contrib/opensolaris/uts/common/fs/zfs/zfs_ioctl.c	(.../stable/8)	(revision 201781)
+++ sys/cddl/contrib/opensolaris/uts/common/fs/zfs/zfs_ioctl.c	(.../projects/capabilities8)	(revision 205872)
@@ -26,6 +26,7 @@
 #include <sys/types.h>
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/capability.h>
 #include <sys/conf.h>
 #include <sys/kernel.h>
 #include <sys/lock.h>

Index: sys/cddl/compat/opensolaris/sys/file.h
===================================================================
--- sys/cddl/compat/opensolaris/sys/file.h	(.../stable/8)	(revision 201781)
+++ sys/cddl/compat/opensolaris/sys/file.h	(.../projects/capabilities8)	(revision 205872)
@@ -34,14 +34,18 @@
 #ifdef _KERNEL
 typedef	struct file	file_t;
 
+#include <sys/capability.h>
+
 static __inline file_t *
 getf(int fd, int write)
 {
 	struct file *fp;
 
-	if (write && fget_write(curthread, fd, &fp) == 0)
+	if (write && fget_write(curthread, fd, CAP_WRITE | CAP_SEEK, &fp) ==
+	    0)
 		return (fp);
-	else if (!write && fget_read(curthread, fd, &fp) == 0)
+	else if (!write && fget_read(curthread, CAP_READ | CAP_SEEK,  fd,
+	    &fp) == 0)
 		return (fp);
 	return (NULL);
 }
Index: sys/security/mac/mac_syscalls.c
===================================================================
--- sys/security/mac/mac_syscalls.c	(.../stable/8)	(revision 201781)
+++ sys/security/mac/mac_syscalls.c	(.../projects/capabilities8)	(revision 205872)
@@ -48,6 +48,7 @@
 #include "opt_mac.h"
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/fcntl.h>
 #include <sys/kernel.h>
 #include <sys/lock.h>
@@ -244,7 +245,7 @@
 	}
 
 	buffer = malloc(mac.m_buflen, M_MACTEMP, M_WAITOK | M_ZERO);
-	error = fget(td, uap->fd, &fp);
+	error = fget(td, uap->fd, CAP_MAC_GET, &fp);
 	if (error)
 		goto out;
 
@@ -439,7 +440,7 @@
 		return (error);
 	}
 
-	error = fget(td, uap->fd, &fp);
+	error = fget(td, uap->fd, CAP_MAC_SET, &fp);
 	if (error)
 		goto out;
 
Index: sys/security/audit/audit_arg.c
===================================================================
--- sys/security/audit/audit_arg.c	(.../stable/8)	(revision 201781)
+++ sys/security/audit/audit_arg.c	(.../projects/capabilities8)	(revision 205872)
@@ -865,6 +865,19 @@
 	ARG_SET_VALID(ar, ARG_ENVV);
 }
 
+void
+audit_arg_rights(cap_rights_t rights)
+{
+	struct kaudit_record *ar;
+
+	ar = currecord();
+	if (ar == NULL)
+		return;
+
+	ar->k_ar.ar_arg_rights = rights;
+	ARG_SET_VALID(ar, ARG_RIGHTS);
+}
+
 /*
  * The close() system call uses it's own audit call to capture the path/vnode
  * information because those pieces are not easily obtained within the system
@@ -886,7 +899,7 @@
 
 	audit_arg_fd(fd);
 
-	if (getvnode(td->td_proc->p_fd, fd, &fp) != 0)
+	if (getvnode_cap(td->td_proc->p_fd, fd, 0, &fp) != 0)
 		return;
 
 	vp = fp->f_vnode;
Index: sys/security/audit/audit_private.h
===================================================================
--- sys/security/audit/audit_private.h	(.../stable/8)	(revision 201781)
+++ sys/security/audit/audit_private.h	(.../projects/capabilities8)	(revision 205872)
@@ -229,6 +229,7 @@
 	int			ar_arg_exitstatus;
 	int			ar_arg_exitretval;
 	struct sockaddr_storage ar_arg_sockaddr;
+	cap_rights_t		ar_arg_rights;
 };
 
 /*
@@ -288,6 +289,7 @@
 #define	ARG_ENVV		0x0002000000000000ULL
 #define	ARG_ATFD1		0x0004000000000000ULL
 #define	ARG_ATFD2		0x0008000000000000ULL
+#define	ARG_RIGHTS		0x0010000000000000ULL
 #define	ARG_NONE		0x0000000000000000ULL
 #define	ARG_ALL			0xFFFFFFFFFFFFFFFFULL
 
Index: sys/security/audit/audit_bsm.c
===================================================================
--- sys/security/audit/audit_bsm.c	(.../stable/8)	(revision 201781)
+++ sys/security/audit/audit_bsm.c	(.../projects/capabilities8)	(revision 205872)
@@ -1581,6 +1581,28 @@
 		}
 		break;
 
+	case AUE_CAP_NEW:
+		/*
+		 * XXXRW: Would be nice to audit socket/etc information also.
+		 */
+		FD_VNODE1_TOKENS;
+		if (ARG_IS_VALID(kar, ARG_RIGHTS)) {
+			tok = au_to_arg64(2, "rights", ar->ar_arg_rights);
+			kau_write(rec, tok);
+		}
+		break;
+
+	case AUE_CAP_GETRIGHTS:
+		if (ARG_IS_VALID(kar, ARG_FD)) {
+			tok = au_to_arg32(1, "fd", ar->ar_arg_fd);
+			kau_write(rec, tok);
+		}
+		break;
+
+	case AUE_CAP_ENTER:
+	case AUE_CAP_GETMODE:
+		break;
+
 	case AUE_NULL:
 	default:
 		printf("BSM conversion requested for unknown event %d\n",
Index: sys/security/audit/audit.h
===================================================================
--- sys/security/audit/audit.h	(.../stable/8)	(revision 201781)
+++ sys/security/audit/audit.h	(.../projects/capabilities8)	(revision 205872)
@@ -114,6 +114,7 @@
 void	 audit_arg_file(struct proc *p, struct file *fp);
 void	 audit_arg_argv(char *argv, int argc, int length);
 void	 audit_arg_envv(char *envv, int envc, int length);
+void	 audit_arg_rights(cap_rights_t rights);
 void	 audit_sysclose(struct thread *td, int fd);
 void	 audit_cred_copy(struct ucred *src, struct ucred *dest);
 void	 audit_cred_destroy(struct ucred *cred);
@@ -235,6 +236,11 @@
 		audit_arg_rgid((rgid));					\
 } while (0)
 
+#define	AUDIT_ARG_RIGHTS(rights) do {					\
+	if (AUDITING_TD(curthread))					\
+		audit_arg_rights((rights));				\
+} while (0)
+
 #define	AUDIT_ARG_RUID(ruid) do {					\
 	if (AUDITING_TD(curthread))					\
 		audit_arg_ruid((ruid));					\
@@ -342,6 +348,7 @@
 #define	AUDIT_ARG_PID(pid)
 #define	AUDIT_ARG_PROCESS(p)
 #define	AUDIT_ARG_RGID(rgid)
+#define	AUDIT_ARG_RIGHTS(rights)
 #define	AUDIT_ARG_RUID(ruid)
 #define	AUDIT_ARG_SIGNUM(signum)
 #define	AUDIT_ARG_SGID(sgid)
Index: sys/security/audit/audit_bsm_errno.c
===================================================================
--- sys/security/audit/audit_bsm_errno.c	(.../stable/8)	(revision 201781)
+++ sys/security/audit/audit_bsm_errno.c	(.../projects/capabilities8)	(revision 205872)
@@ -686,6 +686,13 @@
 	ERRNO_NO_LOCAL_MAPPING,
 #endif
 	ES("Key was rejected by service") },
+	{ BSM_ERRNO_ENOTCAPABLE,
+#ifdef ENOTCAPABLE
+	ENOTCAPABLE,
+#else
+	ERRNO_NO_LOCAL_MAPPING,
+#endif
+	ES("Capabilities insufficient") },
 };
 static const int bsm_errnos_count = sizeof(bsm_errnos) / sizeof(bsm_errnos[0]);
 

Index: sys/amd64/linux32/linux32_machdep.c
===================================================================
--- sys/amd64/linux32/linux32_machdep.c	(.../stable/8)	(revision 201781)
+++ sys/amd64/linux32/linux32_machdep.c	(.../projects/capabilities8)	(revision 205872)
@@ -34,6 +34,7 @@
 #include <sys/param.h>
 #include <sys/kernel.h>
 #include <sys/systm.h>
+#include <sys/capability.h>
 #include <sys/file.h>
 #include <sys/fcntl.h>
 #include <sys/clock.h>
@@ -861,7 +862,7 @@
 		 * protection options specified.
 		 */
 
-		if ((error = fget(td, bsd_args.fd, &fp)) != 0)
+		if ((error = fget(td, bsd_args.fd, CAP_MMAP, &fp)) != 0)
 			return (error);
 		if (fp->f_type != DTYPE_VNODE) {
 			fdrop(fp, td);
Index: sys/amd64/conf/CAPABILITIES
===================================================================
--- sys/amd64/conf/CAPABILITIES	(.../stable/8)	(revision 0)
+++ sys/amd64/conf/CAPABILITIES	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,11 @@
+include GENERIC
+ident CAPABILITIES
+
+options CAPABILITIES
+options PROCDESC
+options KDTRACE_HOOKS
+options INVARIANT_SUPPORT
+options INVARIANTS
+options WITNESS
+options KDB
+options DDB
